/*
 * Created on 08.03.2003
 *
 * Jrgen Seitz 	-	Software nach Mass
 */
package stammdaten;

import interfaces.Anschrift;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

/**
 * @author jrgen seitz
 *
 * einfache Klasse zum Speichern von Adressdaten
 */
public class StandardAdresse {
	
	private static int anschriftCounterClass = 0; 	// wird bei neuer Instanz des Objektes nicht zurckgesetzt !
	private int anschriftCounterInstance = 0; 		// wird bei jeder neuen Instanz des Objektes wieder auf 0 zurckgesetzt !

	private Map anschriften = new HashMap();
	private Integer id;
	private String name;
	private String vorname;
	
	/**
	 * Konstruktor zum Instanzieren einer neuen Adresse mit allen bentigten Werten
	 */
	public StandardAdresse(Integer id, String name, String vorname, StandardAnschrift anschrift) {
		this.id = id;
		this.name = name;
		this.vorname = vorname;
		addAnschrift(Anschrift.DEFAULT_ANSCHRIFT, anschrift);
	}

	/**
	 * Fgt eine andere Anschrift unter einem bestimmten key zur Adresse hinzu
	 * @param key 
	 * @param anschrift 
	 */
	public void addAnschrift(String key, StandardAnschrift anschrift) {
		anschriften.put(key, anschrift);
	}

	/**
	 * @return Integer 
	 * gibt die ID der Adresse als Integer zurck
	 */
	public Integer getId() {
		return id;
	}

	/**
	 * @return StandardAnschrift
	 * gibt die Anschrift der Adresse als StandardAnschrift zurck
	 */
	public StandardAnschrift getAnschrift(String key) {
		++anschriftCounterClass;
		++anschriftCounterInstance;
		System.out.println("classCounter : " + anschriftCounterClass + " instanceCounter : " + anschriftCounterInstance);
		return (StandardAnschrift)anschriften.get(key);
	}

	/**
	 * @return String
	 * gibt den Namen der Adresse als String zurck
	 */
	public String getName() {
		return name;
	}

	/**
	 * @return String
	 * gibt den Vornamen der Adresse als String zurck
	 */
	public String getVorname() {
		return vorname;
	}

	/**
	 * @see java.lang.Object#toString()
	 * gibt die komplette StandardAdresse als String zurck
	 */
	public String toString() {
		String anschriftString = "";
		for (Iterator iterator = anschriften.keySet().iterator(); iterator.hasNext();) {
			String anschriftsTyp = (String) iterator.next();
			anschriftString = anschriftString + ", " + anschriftsTyp + " : " + getAnschrift(anschriftsTyp);
		}
		return "ID: " + getId() + ", " + getVorname() + " " + getName() + anschriftString;
	}
}
